Next: getw, Previous: getline, Up: Stdio

### 4.38 `gets`—get character string (obsolete, use `fgets` instead)

Synopsis

         #include <stdio.h>

         char *gets(char *buf);

         char *_gets_r(struct _reent *reent, char *buf);

Description
Reads characters from standard input until a newline is found. The characters up to the newline are stored in buf. The newline is discarded, and the buffer is terminated with a 0.

This is a dangerous function, as it has no way of checking the amount of space available in buf. One of the attacks used by the Internet Worm of 1988 used this to overrun a buffer allocated on the stack of the finger daemon and overwrite the return address, causing the daemon to execute code downloaded into it over the connection.

The alternate function `_gets_r` is a reentrant version. The extra argument reent is a pointer to a reentrancy structure.

Returns
`gets` returns the buffer passed to it, with the data filled in. If end of file occurs with some data already accumulated, the data is returned with no other indication. If end of file occurs with no data in the buffer, NULL is returned.

Supporting OS subroutines required: `close`, `fstat`, `isatty`, `lseek`, `read`, `sbrk`, `write`.